--[[ $Id: Core.lua 57639 2007-12-29 12:06:04Z borlox $ ]]--
CCopy = LibStub("AceAddon-3.0"):NewAddon("CCopy", "AceHook-3.0")
local CCopy = CCopy

local _G = getfenv(0)

local link_msg = "|HCCopy:%d|h%s|h %s"
local find_id  = "^CCopy:(%d+)"

local ChatFrameEditBox = ChatFrameEditBox

function CCopy:OnInitialize()
	self.messages = {}
	self.dot = '*'	-- you can change this ingame with /run CCopy.dot = 'yourdothere', slash commands and SVs would be to "big" for this mod
end

function CCopy:OnEnable()
	self:RawHook("SetItemRef", true)
	for i=1, NUM_CHAT_WINDOWS do
		self:RawHook(_G["ChatFrame"..i], "AddMessage", true)
	end
end

function CCopy:ClearMessage(msg)
	msg = msg:gsub("|H.-|h(.-)|h", "%1")	-- clear links
	msg = msg:gsub("|c%x%x%x%x%x%x%x%x(.-)|r", "%1") -- clear colors
	return msg
end

function CCopy:ShowMessage(id)
	local msg = self.messages[id] or error(("CCopy:ShowMessage(id): 'id' - There is no message with the id %d."):format(id))
	msg = self:ClearMessage(msg)
	
	ChatFrameEditBox:SetText(ChatFrameEditBox:GetText() .. msg)
	if not ChatFrameEditBox:IsShown() then
		ChatFrameEditBox:Show()
		ChatFrameEditBox:HighlightText()
	end
end

function CCopy:AddMessage(chatFrame, msg, ...)
	local id = #self.messages + 1
	self.messages[id] = msg
	msg = link_msg:format(id, self.dot, msg)
	self.hooks[chatFrame].AddMessage(chatFrame, msg, ...)
end

function CCopy:SetItemRef(link, ...)
	if strsub(link, 1, 5) == "CCopy" then
		local _,_,id = link:find(find_id)
		self:ShowMessage(tonumber(id))
	else
		self.hooks.SetItemRef(link, ...)
	end
end
